$ on warning   then goto final_exit
$ on control_y then goto final_exit
$!
$!=====================================================================
$! Define Variables
$!=====================================================================
$ nodes    = p1
$ uname    = p2
$ pass     = p3
$ cmd      = p4
$ port     = p5
$ me       = f$edit(f$getjpi("","username"), "trim")
$ msglevel = f$environment("message")
$!
$!=====================================================================
$! Get Arguments
$!=====================================================================
$ write sys$output ""
$!
$ if (port .eqs. "")
$ then
$   port = 110
$ endif
$!
$ if (nodes .eqs. "")
$ then
$   read/prompt="IUPOP3 Node(s) > " sys$command nodes
$   nodes = f$edit(nodes, "compress,trim")
$   if (nodes .eqs. "") then goto final_exit
$ endif
$!
$ if (uname .eqs. "")
$ then
$   read/prompt="Username [''me'] > " sys$command uname
$   uname = f$edit(uname, "compress,trim")
$   if (uname .eqs. "") then uname = me
$ endif
$!
$ if (pass .eqs. "")
$ then
$   set term/noecho
$   read/prompt="Password > " sys$command pass
$   write sys$output ""
$   set term/echo
$   pass = f$edit(pass, "compress,trim")
$   if (pass .eqs. "") then goto final_exit
$ endif
$!
$ if (cmd .eqs. "")
$ then
$   read/prompt="XTND command > " sys$command cmd
$   cmd = f$edit(cmd, "compress,trim,upcase")
$   if (cmd .eqs. "") then goto final_exit
$ endif
$!
$!=====================================================================
$! Verify Arguments
$!=====================================================================
$ if (f$environment("INTERACTIVE") .eqs. "TRUE") 
$ then
$   if (cmd .eqs. "SHUTDOWN")
$   then
$     read/prompt="Really shutdown IUPOP3 on ''nodes'? [y/n] > " -
          sys$command reply
$     reply = f$edit(reply, "collapse,trim,upcase")
$     reply = f$extract(0, 1, reply)
$     if (reply .nes. "Y") then goto final_exit
$   endif
$ endif
$!
$!=====================================================================
$! Main Program 
$!=====================================================================
$ count = 0
$ main:
$ node = f$element(count, " ", nodes)
$ if (node .nes. " ") 
$ then
$   gosub do_kermit
$   count = count + 1
$   goto main
$ endif
$ goto final_exit
$!
$!=====================================================================
$! Do Kermit
$!=====================================================================
$ do_kermit:
$ set message/nofacility/noid/notext/noseverity
$ kermit "-C" -
  "define %z ''port', define %u ''uname', define %p ''pass', define %c ''cmd', define %n ''node'"
    set quiet on
    define %t 10
    set input silence \%t
    set input case observe
    set input timeout-action proceed

    define snd     output {\%1\13}
    define errext  input 1 {.}, echo {\10Command failed!, quitting\10} , quit
    define sendln  snd {\%1}, minput \%t {+OK} {-ERR}, if = \v(minput) 2 errext
    define sendit  sendln {\%1}, snd {NOOP}, input 300 {+OK}
    define login   input 2 {+OK}, sendln {USER \%1}, sendln {PASS \%2}
    define logout  do sendln {QUIT}, input 1 {wait}
    define xcmd    do sendit {\%1}
    define newmail do sendit {stat}
    define xtnd    do xcmd {\%1}

    write screen \10 
    set host \%n:\%z
    if not failure do login {\%u} {\%p}
    if not failure do xtnd {\%c}
    if not failure do newmail
    if not failure do logout
    write screen \10 
    exit
$ status = $status
$ set message 'msglevel'
$ if ((status .and. 1) .nes. 1) then write sys$output "''f$message(status)'"
$ return
$!
$!=====================================================================
$! Final Exit
$!=====================================================================
$ final_exit:
$ set term/echo
$ set message 'msglevel'
$ exit
